POJ 3621 Sightseeing Cows 【01分数规划+spfa判正环】

题目链接:http://poj.org/problem?id=3621

Sightseeing Cows

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 11526   Accepted: 3930

Description

Farmer John has decided to reward his cows for their hard work by taking them on a tour of the big city! The cows must decide how best to spend their free time.

Fortunately, they have a detailed city map showing the L (2 ≤ L ≤ 1000) major landmarks (conveniently numbered 1.. L) and the P (2 ≤ P ≤ 5000) unidirectional cow paths that join them. Farmer John will drive the cows to a starting landmark of their choice, from which they will walk along the cow paths to a series of other landmarks, ending back at their starting landmark where Farmer John will pick them up and take them back to the farm. Because space in the city is at a premium, the cow paths are very narrow and so travel along each cow path is only allowed in one fixed direction.

While the cows may spend as much time as they like in the city, they do tend to get bored easily. Visiting each new landmark is fun, but walking between them takes time. The cows know the exact fun values Fi (1 ≤ Fi ≤ 1000) for each landmark i.

The cows also know about the cowpaths. Cowpath i connects landmark L1i to L2i (in the direction L1i -> L2i ) and requires time Ti (1 ≤ Ti ≤ 1000) to traverse.

In order to have the best possible day off, the cows want to maximize the average fun value per unit time of their trip. Of course, the landmarks are only fun the first time they are visited; the cows may pass through the landmark more than once, but they do not perceive its fun value again. Furthermore, Farmer John is making the cows visit at least two landmarks, so that they get some exercise during their day off.

Help the cows find the maximum fun value per unit time that they can achieve.

Input

* Line 1: Two space-separated integers: L and P
* Lines 2..L+1: Line i+1 contains a single one integer: Fi
* Lines L+2..L+P+1: Line L+i+1 describes cow path i with three space-separated integers: L1i , L2i , and Ti

Output

* Line 1: A single number given to two decimal places (do not perform explicit rounding), the maximum possible average fun per unit time, or 0 if the cows cannot plan any trip at all in accordance with the above rules.

Sample Input

5 7
30
10
10
5
10
1 2 3
2 3 2
3 4 5
3 5 2
4 5 5
5 1 3
5 2 2

Sample Output

6.00

Source

USACO 2007 December Gold

题目概括:

有 L 个 landmarks, P条 cow path(有向边),每个点可获得娱乐值 Fi ,不过每条边需要花费时间 Ti,我们要求的是选走任意几个点(路径要构成一个环)单位时间获得最大的娱乐值即 求 ΣFi / ΣTi 的最大值。

解题思路:

要从N中取K,并且求 ΣFi / ΣTi 的最大值,很明显用二分+01分数规划

令 ΣFi / ΣTi >= X, 则 ΣFi - ΣTi*X >= 0, 也就转换为了求这个有向图是否存在正环,我们直到SPFA可以轻松通过dfs判断点的访问次数来判断是否有负环,我们只需要把SPFA的求最短路的判断条件换成求最长路的判断条件即可以判断是否存在正环了。

AC code:

 1 ///POJ 3621 01分数规划+SPFA判断正环
 2 #include <iostream>
 3 #include <stdio.h>
 4 #include <stdlib.h>
 5 #include <algorithm>
 6 #include <string.h>
 7 #include <vector>
 8 #include <math.h>
 9 #include <limits>
10 #include <set>
11 #include <map>
12 #define INF ox3f3f3f3f
13 using namespace std;
14
15 const int MAXN = 505050;
16 int v[MAXN];       ///点权
17 int fst[MAXN], vb[MAXN], vc[MAXN], nxt[MAXN];
18 bool vis[MAXN], fh;                     ///记录访问点的次数
19 double dist[MAXN];    ///用于判断正环
20 int N, M, cnt;
21
22 void add(int a, int b, int c)   ///静态邻接表
23 {
24     ++cnt;
25     nxt[cnt] = fst[a];
26     fst[a] = cnt;
27     vb[cnt] = b;
28     vc[cnt] = c;         ///边权
29 }
30
31 void spfa_dfs(int p, double x)
32 {
33     vis[p] = true;
34     for(int e = fst[p]; e; e = nxt[e])
35     {
36         double C = v[vb[e]]-x*vc[e];
37         if(dist[vb[e]] >= C+dist[p]) continue;   ///与spfa判断负环恰好相反,只取大的
38         if(vis[vb[e]])
39         {
40             fh = 1; return;
41         }
42         dist[vb[e]] = C+dist[p];
43         spfa_dfs(vb[e], x);
44         if(fh) return;
45     }
46     vis[p] = 0;
47 }
48
49 bool ok(double x)
50 {
51     for(int i = 1; i <= N; i++)
52     {
53         vis[i] = dist[i] = 0;
54     }
55     fh = 0;
56     for(int i = 1; i <= N; i++)
57     {
58         spfa_dfs(i, x);
59         if(fh) return true;   ///有正环
60     }
61     return false;
62 }
63 int main()
64 {
65     scanf("%d%d", &N, &M);
66     for(int i = 1; i <= N; i++)
67         scanf("%d", &v[i]);
68     for(int i = 1; i <= M; i++)
69     {
70         int a, b, c;
71         scanf("%d%d%d", &a, &b, &c);
72         add(a, b, c);
73     }
74     double l = 0, r = 1000000000;
75     while(r-l>1e-6)
76     {
77         double mid = (l+r)/2.0;
78         if(ok(mid)) l = mid;
79         else r = mid;
80     }
81     printf("%.2lf\n", l);
82
83     return 0;
84 }

原文地址:https://www.cnblogs.com/ymzjj/p/9426108.html

时间: 2024-10-14 11:19:58

POJ 3621 Sightseeing Cows 【01分数规划+spfa判正环】的相关文章

POJ 3621 Sightseeing Cows 01分数规划,最优比例环的问题

http://www.cnblogs.com/wally/p/3228171.html 题解请戳上面 然后对于01规划的总结 1:对于一个表,求最优比例 这种就是每个点位有benefit和cost,这样就是裸的01规划 2:对于一个树,求最优比例 这种就是每条边有benefit和cost,然后通过最小生成树来判断 3:对于一个环求最优比例 这种也是每条边有benefit和cost,然后通过spfa来判断 其实01规划最核心的地方,在于构建01规划函数,构建好函数,然后根据单调性,判断大于0或者小

POJ 3621 Sightseeing Cows | 01分数规划

题目: http://poj.org/problem?id=3621 题解: 二分答案,检查有没有负环 #include<cstdio> #include<algorithm> #include<cstring> #define N 1005 using namespace std; struct node { int nxt,v; double w; }e[N*5]; int head[N],ecnt,L,P; double dis[N],fun[N],l,r,mid

01分数规划+spfa判负环 POJ3621 Sightseeing Cows

Sightseeing Cows Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 10348   Accepted: 3539 Description Farmer John has decided to reward his cows for their hard work by taking them on a tour of the big city! The cows must decide how best to

poj3621 Sightseeing Cows --- 01分数规划

典型的求最优比例环问题 参考资料: http://blog.csdn.net/hhaile/article/details/8883652 此题中,给出每个点和每条边的权值,求一个环使 ans=∑点权/∑边权 最大. 因为题目要求一个环,而且必然是首尾相接的一个我们理解的纯粹的环,不可能是其他样子的环, 所以我们可以把一条边和指向的点看做整体处理. 上面方程可以化为:ans×e[i]-p[i]=0 以它为边权二分答案,spfa求负环,有负环则该ans可行,增大下界. 若一直不可行,则无解. #i

bzoj1690:[Usaco2007 Dec]奶牛的旅行(分数规划+spfa判负环)

前段时间准备省选没更,后段(?)时间省选考砸没心情更,最近终于开始恢复刷题了... 题目大意:有n个点m条有向边的图,边上有花费,点上有收益,点可以多次经过,但是收益不叠加,边也可以多次经过,但是费用叠加.求一个环使得收益和/花费和最大,输出这个比值. 显然这就是经典的分数规划题啊,就是最优比率环,那么就二分答案,将所有边(u,v)的边权改为[v的点权-(u,v)原边权*mid],这可以算是最优比率环的公式了吧,然后判一下是否有正环,有的话就说明答案可行.判正环有够别扭的,那就全部改成相反数然后

bzoj 1690: [Usaco2007 Dec]奶牛的旅行——分数规划+spfa判负环

Description 作为对奶牛们辛勤工作的回报,Farmer John决定带她们去附近的大城市玩一天.旅行的前夜,奶牛们在兴奋地讨论如何最好地享受这难得的闲暇. 很幸运地,奶牛们找到了一张详细的城市地图,上面标注了城市中所有L(2 <= L <= 1000)座标志性建筑物(建筑物按1..L顺次编号),以及连接这些建筑物的P(2 <= P <= 5000)条道路. 按照计划,那天早上Farmer John会开车将奶牛们送到某个她们指定的建筑物旁边,等奶牛们完成她们的整个旅行并回到

poj 3621 Sightseeing Cows(最优比例生成环,01分数规划)

http://poj.org/problem?id=3621 大致题意:给出一个有向图,每个点都有一个点权,每条有向边也都有一个边权,要求出一个环使得环中点权之和与边权之和的比值最大. 思路:和最优比率生成树异曲同工.设点权是v[i],边权是e[i].不同的是这里一个是点,一个是边.怎么像生成树一样把这两个值放到一起呢?可以把他们都转化到边上.同样的二分λ,每次给边重新赋权为v[i] - λ*e[i](v[i]是该边终点的点权).因为要求比值最大,那么在这前提下于图中的所有环都<=0, 所以我们

POJ 3621 Sightseeing Cows 最大密度环 01分数规划

最大密度环 01分数规划 首先的一个结论就是,不会存在环套环的问题,即最优的方案一定是一个单独的环,而不是大环套着小环的形式.这个的证明其实非常的简单,大家可以自己想一下(提示,将大环上的收益和记为x1,花费为y1,小环上的为x2,y2.重叠部分的花费为S.表示出来分类讨论即可).有了这个结论,我们就可以将花费和收益都转移到边上来了,因为答案最终一定是一个环,所以我们将每一条边的收益规定为其终点的收益,这样一个环上所有的花费和收益都能够被正确的统计. 解决了蛋疼的问题之后,就是01分数规划的部分

POJ 3621 Sightseeing Cows(最优比例环+SPFA检测)

Sightseeing Cows Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 10306   Accepted: 3519 Description Farmer John has decided to reward his cows for their hard work by taking them on a tour of the big city! The cows must decide how best to